import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import { AddTagsToOnPremisesInstancesInput } from "../models/models_0";
export interface AddTagsToOnPremisesInstancesCommandInput
  extends AddTagsToOnPremisesInstancesInput {}
export interface AddTagsToOnPremisesInstancesCommandOutput
  extends __MetadataBearer {}
export declare class AddTagsToOnPremisesInstancesCommand extends $Command<
  AddTagsToOnPremisesInstancesCommandInput,
  AddTagsToOnPremisesInstancesCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: AddTagsToOnPremisesInstancesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: AddTagsToOnPremisesInstancesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    AddTagsToOnPremisesInstancesCommandInput,
    AddTagsToOnPremisesInstancesCommandOutput
  >;
  private serialize;
  private deserialize;
}
