import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  BatchGetOnPremisesInstancesInput,
  BatchGetOnPremisesInstancesOutput,
} from "../models/models_0";
export interface BatchGetOnPremisesInstancesCommandInput
  extends BatchGetOnPremisesInstancesInput {}
export interface BatchGetOnPremisesInstancesCommandOutput
  extends BatchGetOnPremisesInstancesOutput,
    __MetadataBearer {}
export declare class BatchGetOnPremisesInstancesCommand extends $Command<
  BatchGetOnPremisesInstancesCommandInput,
  BatchGetOnPremisesInstancesCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: BatchGetOnPremisesInstancesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetOnPremisesInstancesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    BatchGetOnPremisesInstancesCommandInput,
    BatchGetOnPremisesInstancesCommandOutput
  >;
  private serialize;
  private deserialize;
}
