import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  CreateDeploymentConfigInput,
  CreateDeploymentConfigOutput,
} from "../models/models_0";
export interface CreateDeploymentConfigCommandInput
  extends CreateDeploymentConfigInput {}
export interface CreateDeploymentConfigCommandOutput
  extends CreateDeploymentConfigOutput,
    __MetadataBearer {}
export declare class CreateDeploymentConfigCommand extends $Command<
  CreateDeploymentConfigCommandInput,
  CreateDeploymentConfigCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: CreateDeploymentConfigCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateDeploymentConfigCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    CreateDeploymentConfigCommandInput,
    CreateDeploymentConfigCommandOutput
  >;
  private serialize;
  private deserialize;
}
