import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  DeleteDeploymentGroupInput,
  DeleteDeploymentGroupOutput,
} from "../models/models_0";
export interface DeleteDeploymentGroupCommandInput
  extends DeleteDeploymentGroupInput {}
export interface DeleteDeploymentGroupCommandOutput
  extends DeleteDeploymentGroupOutput,
    __MetadataBearer {}
export declare class DeleteDeploymentGroupCommand extends $Command<
  DeleteDeploymentGroupCommandInput,
  DeleteDeploymentGroupCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: DeleteDeploymentGroupCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteDeploymentGroupCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteDeploymentGroupCommandInput,
    DeleteDeploymentGroupCommandOutput
  >;
  private serialize;
  private deserialize;
}
