import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  DeleteGitHubAccountTokenInput,
  DeleteGitHubAccountTokenOutput,
} from "../models/models_0";
export interface DeleteGitHubAccountTokenCommandInput
  extends DeleteGitHubAccountTokenInput {}
export interface DeleteGitHubAccountTokenCommandOutput
  extends DeleteGitHubAccountTokenOutput,
    __MetadataBearer {}
export declare class DeleteGitHubAccountTokenCommand extends $Command<
  DeleteGitHubAccountTokenCommandInput,
  DeleteGitHubAccountTokenCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: DeleteGitHubAccountTokenCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteGitHubAccountTokenCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteGitHubAccountTokenCommandInput,
    DeleteGitHubAccountTokenCommandOutput
  >;
  private serialize;
  private deserialize;
}
