import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import { DeregisterOnPremisesInstanceInput } from "../models/models_0";
export interface DeregisterOnPremisesInstanceCommandInput
  extends DeregisterOnPremisesInstanceInput {}
export interface DeregisterOnPremisesInstanceCommandOutput
  extends __MetadataBearer {}
export declare class DeregisterOnPremisesInstanceCommand extends $Command<
  DeregisterOnPremisesInstanceCommandInput,
  DeregisterOnPremisesInstanceCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: DeregisterOnPremisesInstanceCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeregisterOnPremisesInstanceCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeregisterOnPremisesInstanceCommandInput,
    DeregisterOnPremisesInstanceCommandOutput
  >;
  private serialize;
  private deserialize;
}
