import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  GetApplicationRevisionInput,
  GetApplicationRevisionOutput,
} from "../models/models_0";
export interface GetApplicationRevisionCommandInput
  extends GetApplicationRevisionInput {}
export interface GetApplicationRevisionCommandOutput
  extends GetApplicationRevisionOutput,
    __MetadataBearer {}
export declare class GetApplicationRevisionCommand extends $Command<
  GetApplicationRevisionCommandInput,
  GetApplicationRevisionCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: GetApplicationRevisionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetApplicationRevisionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetApplicationRevisionCommandInput,
    GetApplicationRevisionCommandOutput
  >;
  private serialize;
  private deserialize;
}
