import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  GetDeploymentConfigInput,
  GetDeploymentConfigOutput,
} from "../models/models_0";
export interface GetDeploymentConfigCommandInput
  extends GetDeploymentConfigInput {}
export interface GetDeploymentConfigCommandOutput
  extends GetDeploymentConfigOutput,
    __MetadataBearer {}
export declare class GetDeploymentConfigCommand extends $Command<
  GetDeploymentConfigCommandInput,
  GetDeploymentConfigCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: GetDeploymentConfigCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetDeploymentConfigCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetDeploymentConfigCommandInput, GetDeploymentConfigCommandOutput>;
  private serialize;
  private deserialize;
}
