import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  GetDeploymentInstanceInput,
  GetDeploymentInstanceOutput,
} from "../models/models_0";
export interface GetDeploymentInstanceCommandInput
  extends GetDeploymentInstanceInput {}
export interface GetDeploymentInstanceCommandOutput
  extends GetDeploymentInstanceOutput,
    __MetadataBearer {}
export declare class GetDeploymentInstanceCommand extends $Command<
  GetDeploymentInstanceCommandInput,
  GetDeploymentInstanceCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: GetDeploymentInstanceCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetDeploymentInstanceCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetDeploymentInstanceCommandInput,
    GetDeploymentInstanceCommandOutput
  >;
  private serialize;
  private deserialize;
}
