import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  GetOnPremisesInstanceInput,
  GetOnPremisesInstanceOutput,
} from "../models/models_0";
export interface GetOnPremisesInstanceCommandInput
  extends GetOnPremisesInstanceInput {}
export interface GetOnPremisesInstanceCommandOutput
  extends GetOnPremisesInstanceOutput,
    __MetadataBearer {}
export declare class GetOnPremisesInstanceCommand extends $Command<
  GetOnPremisesInstanceCommandInput,
  GetOnPremisesInstanceCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: GetOnPremisesInstanceCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetOnPremisesInstanceCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetOnPremisesInstanceCommandInput,
    GetOnPremisesInstanceCommandOutput
  >;
  private serialize;
  private deserialize;
}
