import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListApplicationRevisionsInput,
  ListApplicationRevisionsOutput,
} from "../models/models_0";
export interface ListApplicationRevisionsCommandInput
  extends ListApplicationRevisionsInput {}
export interface ListApplicationRevisionsCommandOutput
  extends ListApplicationRevisionsOutput,
    __MetadataBearer {}
export declare class ListApplicationRevisionsCommand extends $Command<
  ListApplicationRevisionsCommandInput,
  ListApplicationRevisionsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListApplicationRevisionsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListApplicationRevisionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListApplicationRevisionsCommandInput,
    ListApplicationRevisionsCommandOutput
  >;
  private serialize;
  private deserialize;
}
