import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListDeploymentConfigsInput,
  ListDeploymentConfigsOutput,
} from "../models/models_0";
export interface ListDeploymentConfigsCommandInput
  extends ListDeploymentConfigsInput {}
export interface ListDeploymentConfigsCommandOutput
  extends ListDeploymentConfigsOutput,
    __MetadataBearer {}
export declare class ListDeploymentConfigsCommand extends $Command<
  ListDeploymentConfigsCommandInput,
  ListDeploymentConfigsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListDeploymentConfigsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListDeploymentConfigsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListDeploymentConfigsCommandInput,
    ListDeploymentConfigsCommandOutput
  >;
  private serialize;
  private deserialize;
}
