import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListDeploymentGroupsInput,
  ListDeploymentGroupsOutput,
} from "../models/models_0";
export interface ListDeploymentGroupsCommandInput
  extends ListDeploymentGroupsInput {}
export interface ListDeploymentGroupsCommandOutput
  extends ListDeploymentGroupsOutput,
    __MetadataBearer {}
export declare class ListDeploymentGroupsCommand extends $Command<
  ListDeploymentGroupsCommandInput,
  ListDeploymentGroupsCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListDeploymentGroupsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListDeploymentGroupsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListDeploymentGroupsCommandInput,
    ListDeploymentGroupsCommandOutput
  >;
  private serialize;
  private deserialize;
}
