import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListDeploymentInstancesInput,
  ListDeploymentInstancesOutput,
} from "../models/models_0";
export interface ListDeploymentInstancesCommandInput
  extends ListDeploymentInstancesInput {}
export interface ListDeploymentInstancesCommandOutput
  extends ListDeploymentInstancesOutput,
    __MetadataBearer {}
export declare class ListDeploymentInstancesCommand extends $Command<
  ListDeploymentInstancesCommandInput,
  ListDeploymentInstancesCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListDeploymentInstancesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListDeploymentInstancesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListDeploymentInstancesCommandInput,
    ListDeploymentInstancesCommandOutput
  >;
  private serialize;
  private deserialize;
}
