import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  ListOnPremisesInstancesInput,
  ListOnPremisesInstancesOutput,
} from "../models/models_0";
export interface ListOnPremisesInstancesCommandInput
  extends ListOnPremisesInstancesInput {}
export interface ListOnPremisesInstancesCommandOutput
  extends ListOnPremisesInstancesOutput,
    __MetadataBearer {}
export declare class ListOnPremisesInstancesCommand extends $Command<
  ListOnPremisesInstancesCommandInput,
  ListOnPremisesInstancesCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: ListOnPremisesInstancesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListOnPremisesInstancesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListOnPremisesInstancesCommandInput,
    ListOnPremisesInstancesCommandOutput
  >;
  private serialize;
  private deserialize;
}
