import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import { RegisterApplicationRevisionInput } from "../models/models_0";
export interface RegisterApplicationRevisionCommandInput
  extends RegisterApplicationRevisionInput {}
export interface RegisterApplicationRevisionCommandOutput
  extends __MetadataBearer {}
export declare class RegisterApplicationRevisionCommand extends $Command<
  RegisterApplicationRevisionCommandInput,
  RegisterApplicationRevisionCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: RegisterApplicationRevisionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: RegisterApplicationRevisionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    RegisterApplicationRevisionCommandInput,
    RegisterApplicationRevisionCommandOutput
  >;
  private serialize;
  private deserialize;
}
