import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import { RegisterOnPremisesInstanceInput } from "../models/models_0";
export interface RegisterOnPremisesInstanceCommandInput
  extends RegisterOnPremisesInstanceInput {}
export interface RegisterOnPremisesInstanceCommandOutput
  extends __MetadataBearer {}
export declare class RegisterOnPremisesInstanceCommand extends $Command<
  RegisterOnPremisesInstanceCommandInput,
  RegisterOnPremisesInstanceCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: RegisterOnPremisesInstanceCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: RegisterOnPremisesInstanceCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    RegisterOnPremisesInstanceCommandInput,
    RegisterOnPremisesInstanceCommandOutput
  >;
  private serialize;
  private deserialize;
}
