import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import { SkipWaitTimeForInstanceTerminationInput } from "../models/models_0";
export interface SkipWaitTimeForInstanceTerminationCommandInput
  extends SkipWaitTimeForInstanceTerminationInput {}
export interface SkipWaitTimeForInstanceTerminationCommandOutput
  extends __MetadataBearer {}
export declare class SkipWaitTimeForInstanceTerminationCommand extends $Command<
  SkipWaitTimeForInstanceTerminationCommandInput,
  SkipWaitTimeForInstanceTerminationCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: SkipWaitTimeForInstanceTerminationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: SkipWaitTimeForInstanceTerminationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    SkipWaitTimeForInstanceTerminationCommandInput,
    SkipWaitTimeForInstanceTerminationCommandOutput
  >;
  private serialize;
  private deserialize;
}
