import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeDeployClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeDeployClient";
import {
  UpdateDeploymentGroupInput,
  UpdateDeploymentGroupOutput,
} from "../models/models_0";
export interface UpdateDeploymentGroupCommandInput
  extends UpdateDeploymentGroupInput {}
export interface UpdateDeploymentGroupCommandOutput
  extends UpdateDeploymentGroupOutput,
    __MetadataBearer {}
export declare class UpdateDeploymentGroupCommand extends $Command<
  UpdateDeploymentGroupCommandInput,
  UpdateDeploymentGroupCommandOutput,
  CodeDeployClientResolvedConfig
> {
  readonly input: UpdateDeploymentGroupCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateDeploymentGroupCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeDeployClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateDeploymentGroupCommandInput,
    UpdateDeploymentGroupCommandOutput
  >;
  private serialize;
  private deserialize;
}
